@echo off
rem Always you must be carefull for spaces and special characters in path name

if "%~1" == "make" goto build_using_makefile_directly

rem ==========================================================================
:build_using_e2studio_headlessbuild
rem ==========================================================================

rem TODO: Check existance of eclipse folder
rem TODO: Check existance of eclipsec.exe and eclipsec.ini

rem Setup tool paths
set Path=%ECLIPSE_HOME%;%Path%

echo ========== Start e2 studio headless build(%DATE% %TIME: =%) ==========

rem Import the project to the dedicated headless build workspace
set CMDLINE=eclipsec.exe -nl en_US -nosplash --launcher.suppressErrors -application org.eclipse.cdt.managedbuilder.core.headlessbuild ^
-no-indexer -data %3 -import %4 %2 %5
ECHO %CMDLINE%
%CMDLINE%

set BUILDERRORLEVEL=%ERRORLEVEL%
echo ''

rem Remove the project from the dedicated headless build workspace
set CMDLINE=eclipsec.exe -nl en_US -nosplash --launcher.suppressErrors -application org.eclipse.cdt.managedbuilder.core.headlessbuild ^
-no-indexer -data %3 -remove %4
ECHO %CMDLINE%
%CMDLINE%

:build_using_e2studio_headlessbuild_exit

echo ========== End e2 studio headless build(%DATE% %TIME: =%) ==========

exit %BUILDERRORLEVEL%

rem ==========================================================================
:build_using_makefile_directly
rem ==========================================================================

rem TODO: Check existance of Utility folder
rem TODO: Check existance of make.exe

rem setup tool paths
set Path=%TCINSTALL%\bin;%SUPPORT_AREA%\Utilities;%Path%

rem get other options
call :get_other_options %*

echo ========== Start build using makefile generated by e2 studio(%DATE% %TIME: =%) ==========

if "%~2" == "build" goto build_using_makefile_directly___skip_clean

rem make clean
chdir /d %3
set CMDLINE=make.exe %OPTIONS% clean
ECHO %CMDLINE%
%CMDLINE% 2>&1

if ERRORLEVEL 1 goto :build_using_makefile_directly___exit

:build_using_makefile_directly___skip_clean

rem make all
chdir /d %3
set CMDLINE=make.exe %OPTIONS% all
ECHO %CMDLINE%
%CMDLINE% 2>&1

:build_using_makefile_directly___exit

echo ========== End build using makefile generated by e2 studio(%DATE% %TIME: =%) ==========

exit %ERRORLEVEL%

rem ==========================================================================
:get_other_options
rem ==========================================================================

set OPTIONS=
:get_other_options_loop
if "%~4" == "" goto get_other_options_loop_break
if "%~5" == "" (set OPTIONS=%OPTIONS%%4) else (set OPTIONS=%OPTIONS%%4 )
shift
goto get_other_options_loop
:get_other_options_loop_break

goto :EOF

rem ==========================================================================
:get_tcinstall_path
rem ==========================================================================

if "%~1" == "" (
    echo \\^> BUILD : error : Folder containing makefile is not defined. Please check the task setting json file.
    exit -1
)
if not exist "%~dp1" (
    echo \\^> BUILD : error : The following folder is not found. Please check the task setting json file.^
 "%~dp1"
    exit -1
)
if not exist "%~dp1makefile" (
    echo \\^> BUILD : error : The following file is not found. Please setup makefile and other make files.^
 "%~dp1makefile"
    exit -1
)
if not exist "%~dp1makefile.init" (
    echo \\^> BUILD : error : The following file is not found. Please setup makefile and other make files including the file.^
 "%~dp1makefile.init"
    exit -1
)
for /f "usebackq tokens=1,2* delims=:= " %%I in ("%~dp1makefile.init") do (
    if "%%~I" == "PATH" if "%%~J" == "$(PATH)" if not "%%~K" == "" (
        set TCINSTALL=%%K\..
    )
    if "%%~I" == "export" if "%%~J" == "BIN_RX" if not "%%~K" == "" (
        set TCINSTALL=%%K\..
    )
)
if "%TCINSTALL%" == "" (
    echo \\^> BUILD : error : The following makefile.init is not supported. Please contact to 'japan.renesasrulz.com/cafe_rene/f/forum21'.^
 "%~dp1makefile.init"
    exit -1
)

goto :EOF
